///////////////////////////////////////////////////////////////////////
//
// David Cheung
// U49303740
// CS 540: AI
// HW 1
// Feb 10, 1999
//////////////////////////////////////////////////////////////////////
// AI.cpp: implementation of the AI class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "AI.h"
#include "stdio.h"
#include "linklist.h"
#include "node.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AI::AI()
{
	goal[0]=1;
	goal[1]=2;
	goal[2]=3;
	goal[3]=4;
	goal[4]=5;
	goal[5]=6;
	goal[6]=7;
	goal[7]=8;
	goal[8]=9;
	maxdepth=25;
	elm = new tree;
	q = new linklist;
	tabloid = new reporter;
}

AI::~AI()
{

}

void AI::arraycp(int arraysource[], int arraydest[])
{
	int tmp_int=0;
	for(tmp_int=0;tmp_int<9;tmp_int++)
	{
		arraydest[tmp_int]=arraysource[tmp_int];
	}

}

bool AI::sucessor(char type)
{
	// The sucessor function is suppose to take in a 
	// node and expand it according to available
	// operators and then stick them in the trees
	// and queues. 
	node *nodemaker;
	if (elm->numnode==0)
	{
		// if the tree has no nodes, then make an
		// initial state.
		nodemaker = new node;
		// report
		//
		tabloid->nodesgenperinstance++;
		//
		//
		nodemaker->stuffdata(init);
		elm->addnode(nodemaker);
		q->addnode(nodemaker);
		//REPORT
		//
		tabloid->statesconsidered++;

		if(goaltest(nodemaker))
		{
			//REPORT
			//
			tabloid->depth=nodemaker->depth;
			return true;

		}
		else return false;
	}
	nodemaker=q->pop(); // pop out from the queue's head
	elm->curptr=nodemaker;

	//REPORT
	//
	tabloid->statesconsidered++;
	//goal test: if goal test true, then end search!
	//
	if(goaltest(nodemaker)) 
	{
		//REPORT
		//
		tabloid->depth=nodemaker->depth;
		return true;
	}
	if(nodemaker->depth >= maxdepth) 
	{
		return false;
	}
	int thenine;
	thenine=AI::wherenine(nodemaker);
	int i=0;
	node *nodechild;
	listavailop(nodemaker);
	for (i=0;i<4;i++)
	{
		if(availop[i]==1)
		{
			// at this point...will try to create
			// the most number of child states
			nodechild=new node(nodemaker);
			// report
			//
			tabloid->nodesgenperinstance++;
			//
			//

			if (i==0)
			{
				// move left is available.
				operation(nodechild,thenine,'l');
			}
			if (i==1) operation(nodechild,thenine,'r');
			if (i==2) operation(nodechild,thenine,'u');
			if (i==3) operation(nodechild,thenine,'d');
		
			if (elm->querydata(nodechild))
				delete nodechild;
			else
			{
				elm->addnode(nodechild);
				// if type is 'h', then enqueue at head.
				// else enqueue at end.
				// by default it is enqueue at head, and
				// pop function by default enqueue
				q->addnode(nodechild, type);
				// 
				// reporting..
				//
				tabloid->numstatesgenerated++;
			}
		}

	}
	return false;
	// sucessor function tested and worked correctly.

}

bool AI::goaltest(node *tnode)
{
	bool flag=true;
	int i=0;
	for (i=0;i<9;i++)
	{
		if (!(tnode->data[i]==goal[i]))
		{
			flag=false;
		}
	}
	return flag;
}

void AI::operation(node *tnode, int nineis, char op)
{
	if(op=='l')
	{
		// attempt to move nineis to the left...
		swapcell(tnode->data, nineis, nineis-1);
	}
	else 
	{
		if(op=='r')
		{
			// attempt to move nineis to the right
			swapcell(tnode->data, nineis, nineis+1);
		}
		else
		{
			if(op=='u') swapcell(tnode->data, nineis, nineis-3);
			else
			{
				if(op=='d') swapcell(tnode->data,
								nineis, nineis+3);
			}
		}
	}
}

void AI::swapcell(int array[], int a, int b)
{
	int tmp;
	tmp=array[a];
	array[a]=array[b];
	array[b]=tmp;
}

int AI::wherenine(node *tnode)
{
	// this function return the numeric value
	// of the cell where the nine is...
	int tmp=0;
	for (tmp=0; tmp<9;tmp++)
	{
		if(tnode->data[tmp]==9)
			return tmp;
	}
	return 0;
}

void AI::listavailop(node *tnode)
{
	availop[0]=0;
	availop[1]=0;
	availop[2]=0;
	availop[3]=0;
	int nine;
	nine=wherenine(tnode);
	if ((!(nine==2) && !(nine==5) && !(nine==8)))
		availop[1]=1;  // can move right
	if ((!(nine==0) &&
		!(nine==3) &&
		!(nine==6)))
		availop[0]=1;	// can move left
	if ((!(nine==0) &&
		!(nine==1) &&
		!(nine==2)))
		availop[2]=1;	// can move up
	if ((!(nine==6) &&
		!(nine==7) &&
		!(nine==8)))
		availop[3]=1;	// can move down

}

void AI::breadthsearch(void)
{
	int i=0;
	bool solutionfoundyet=false;
	bool failed=false;  // fail solution flag
	fprintf(ofp,"performing breadth-first-search...\n");
	testnode.stuffdata(init);
	tabloid->initnode.stuffdata(init);
	fprintf(ofp, "For instance :");
	testnode.printfile(ofp);
	do
	{
		solutionfoundyet=sucessor('e');
		
		i++;
		if(q->numnode==0 && !(i==0)) failed=true;
	}while( !failed && !solutionfoundyet);


	if(q->numnode==0)
		fprintf(ofp," search failed! all solutions exhausted.\n");
	else
	{
		fprintf(ofp," Solution found! the solution is: \n");
		elm->printpathfile(ofp);
	}
	AI::clean();
}

void AI::depthsearch()
{
	int i=0;
	maxdepth=30;
	bool solutionfoundyet=false;
	bool failed=false;  // fail solution flag
	fprintf(ofp,"performing depth-first-search...\n");
	testnode.stuffdata(init);
	tabloid->initnode.stuffdata(init);
	fprintf(ofp, "For instance :");
	testnode.printfile(ofp);
	
	do
	{
		solutionfoundyet=sucessor('h');
		
		i++;
		if(q->numnode==0 && !(i==0)) failed=true;
	}while( !failed && !solutionfoundyet);


	if(q->numnode==0)
		fprintf(ofp," search failed! all solutions exhausted.\n");
	else
	{
		fprintf(ofp," Solution found! the solution is: \n");
		elm->printpathfile(ofp);
	}

}

void AI::iteradeepsearch()
{
	int i=0;
	maxdepth=25;
	bool solutionfoundyet=false;
	bool failed=false;  // fail solution flag
	fprintf(ofp,"performing iterative deepening-search...\n");
	testnode.stuffdata(init);
	tabloid->initnode.stuffdata(init);
	fprintf(ofp, "For instance :");
	testnode.printfile(ofp);

	for(maxdepth=1;maxdepth <=25;maxdepth++)
	{
		do
		{
			solutionfoundyet=sucessor('h');
		
			i++;
			if(q->numnode==0 && !(i==0)) failed=true;
		}while( !failed && !solutionfoundyet);
		if (failed) clean();
		i=0;
		if(maxdepth <= 24) failed=0;
		// see, it doesn't really failed until 
		// the loop has done for many times.
	}

	if(failed)	
		fprintf(ofp," search failed! all solutions exhausted.\n");
	else
	{
		fprintf(ofp," Solution found! the solution is: \n");
		elm->printpathfile(ofp);
	}


}

void AI::taskengine(char type)
{
	// if the type is "b" then implies breath search
	// if type is "d" then implies depth search
	// if type is "i" then implies iterative deepening search.

	FILE *ifp; // input file pointer
	ifp=fopen("assn1.txt","r");
	int tmp[9];
	//reset a tabloid:
	delete tabloid;
	tabloid = new reporter;
	// report
	//
	tabloid->searchtype=type;

	switch (type)
	{
		case 'b': 	ofp=fopen("breadthout.txt","w");
					tabloid->getofp(fopen("breadthrep.txt","w"));
					break;
		case 'd':	ofp=fopen("depthout.txt","w");
					tabloid->getofp(fopen("depthrep.txt","w"));
					break;
		case 'i':	ofp=fopen("iteraout.txt","w");
					tabloid->getofp(fopen("iterarep.txt","w"));
					break;
	}

	while(	(fscanf(ifp,"%d %d %d %d %d %d %d %d %d \n",
			&tmp[0],&tmp[1],&tmp[2],
			&tmp[3],&tmp[4],&tmp[5],
			&tmp[6],&tmp[7],&tmp[8]) >=0))
	{
		arraycp(tmp,AI::init);

		switch (type)
		{
			case 'b': 	breadthsearch();
						break;
			case 'd':	AI::depthsearch();
						break;
			case 'i':	AI::iteradeepsearch();
						break;
		}

		tabloid->instancereport();
		tabloid->instancereset();

		AI::clean(); // cleans the tree and q every
					// instance.
	}
	tabloid->overallreport();
//	
//	
}

void AI::clean()
{
	// cleans the tree and q's and create them again.
	delete elm;
	delete q;
	elm=new tree;
	q=new linklist;
}

//////////////////////////////////////////////////////////////////////
// reporter Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

reporter::reporter()
{
	statesconsidered=0;
	statesgenpernode=0;
	nodesgenperinstance=0;
	numstatesgenerated=0;
	depth=0;
	initnode=0;
	maxstates=0;
	minstates=0;
	numinstances=0;
	cumstates=0;
	avestates=0;

}

reporter::~reporter()
{

}

void reporter::getofp(FILE *fptr)
{
	ofp=fptr;
}


void reporter::overallreport()
{
	avestates=(float)cumstates / (float)numinstances;
	fprintf(reporter::ofp, "*********************************\n");
	fprintf(reporter::ofp, "Overall Report:\n");
	fprintf(reporter::ofp, "Search Type: ");
	switch (reporter::searchtype)
	{
	case 'b': fprintf(reporter::ofp, "Breadth first\n");
			break;
	case 'd': fprintf(reporter::ofp, "Depth first \n");
			break;
	case 'i': fprintf(reporter::ofp, "Iterative Deepening \n");
			break;
	default:
			fprintf(reporter::ofp, "Unknown \n");
			break;
	}
	fprintf(reporter::ofp, "Num of Instances worked: %d\n", numinstances);
	fprintf(reporter::ofp, "Max states generated : %d\n",maxstates);
	fprintf(reporter::ofp, "Min states generated : %d\n",minstates);
	fprintf(reporter::ofp, "Ave states generated : %.2f\n",avestates);
	fprintf(reporter::ofp, "*********************************\n");

}

void reporter::instancereport()
{
	fprintf(reporter::ofp, "*********************************\n");
	fprintf(reporter::ofp, "Instance : ");
	reporter::initnode.printfile(reporter::ofp);
	fprintf(reporter::ofp, "Search type : ");
	switch (reporter::searchtype)
	{
	case 'b': fprintf(reporter::ofp, "Breadth first\n");
			break;
	case 'd': fprintf(reporter::ofp, "Depth first \n");
			break;
	case 'i': fprintf(reporter::ofp, "Iterative Deepening \n");
			break;
	default:
			fprintf(reporter::ofp, "Unknown \n");
			break;
	}
	fprintf(reporter::ofp, "Depth of goal state: %d\n",reporter::depth);
	fprintf(reporter::ofp, "Nodes generated : %d \n", nodesgenperinstance);
	fprintf(reporter::ofp, "States generated : %d \n", numstatesgenerated);
	fprintf(reporter::ofp, "States considered : %d \n",statesconsidered);
	fprintf(reporter::ofp, "*********************************\n");

}


void reporter::instancereset()
{
	cumstates=cumstates+numstatesgenerated;
	numinstances++;
	if(maxstates<numstatesgenerated) maxstates=numstatesgenerated;
	if((minstates==0) || (minstates > numstatesgenerated))
		minstates=numstatesgenerated;
	reporter::nodesgenperinstance=0;
	reporter::numstatesgenerated=0;
	reporter::statesconsidered=0;


}
