// AI.h: interface for the AI class.
//
//////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////
//
// David Cheung
// U49303740
// CS 540: AI
// HW 1
// Feb 10, 1999
//////////////////////////////////////////////////////////////////////
#if !defined(AFX_AI_H__D7C140E1_BC14_11D2_BB12_0080AD311DDC__INCLUDED_)
#define AFX_AI_H__D7C140E1_BC14_11D2_BB12_0080AD311DDC__INCLUDED_
#include "node.h"
#include "linklist.h"
#include "tree.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class reporter  
{
public:
	int cumstates;
	void instancereset();
	float avestates;
	int minstates;
	int maxstates;
	char searchtype;
	int numinstances;
	int numstatesgenerated;
	node initnode;
	void instancereport();
	int depth;
	void overallreport();
	void getofp(FILE *fptr);
	int statesconsidered;
	int statesgenpernode;
	int nodesgenperinstance;
	reporter();
	virtual ~reporter();
private:
	FILE * ofp;

};
class AI  
{
public:
	reporter *tabloid;
	void clean();
	FILE * ofp;
	void taskengine(char type='b');
	void iteradeepsearch();
	int maxdepth;
	void depthsearch();
	void breadthsearch();
	void listavailop(node *);
	int wherenine(node *);
	void swapcell(int array[],int a, int b);
	void operation(node *, int nineis, char op);
	node testnode;
	bool goaltest(node *);
	bool sucessor(char type='h');
	void arraycp(int arraysource[], int arraydest[]);
	int init[9];
	int goal[9];
	tree *elm;
	linklist *q;
	AI();
	virtual ~AI();

private:
	int availop[4];
	// the availop array works as follows:
	// [0] = left
	// [1] = right
	// [2] = up
	// [3] = down
	// if that cell has a one, then that means that move is 
	//	available.

};



#endif // !defined(AFX_AI_H__D7C140E1_BC14_11D2_BB12_0080AD311DDC__INCLUDED_)
