// hw1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "stdio.h"
///////////////////////////////////////////////////////////////////////
//
// David Cheung
// U49303740
// CS 540: AI
// HW 1
// Feb 10, 1999
//////////////////////////////////////////////////////////////////////
#include "node.h"
#include "linklist.h"
#include "tree.h"
#include "AI.h"


void arraycp(int arraysource[], int arraydest[])
{
	int tmp_int=0;
	for(tmp_int=0;tmp_int<9;tmp_int++)
	{
		arraydest[tmp_int]=arraysource[tmp_int];
	}
}


int main(int argc, char* argv[])
{

	// how to use the lists and nodes...
	// to create a node, use node test or
	// node *test = new node.
	// when you want to pass it into a linklist
	// or tree, to linklist.addnode(node)
	// if the node is a pointer, do above, else
	// do: linklist.addnode(&nodename)
	AI hal;
//	hal.taskengine('b'); // Hal does breadth first
//	hal.taskengine('d'); // hal does depth first
	hal.taskengine('i'); // hal does iterative deepening search
	return 0;
}



//////////////////////////////////////////////////////////////////////
// node Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
static int ident=0;

node::node(int a, int b, int c,
		   int d, int e, int f,
		   int g, int h, int i)
{

	id=++ident;
	parent=NULL;
	sister=NULL;
	child=NULL;
	next=NULL;
	prev=NULL;
	stuffdata(a,b,c,d,e,f,g,h,i);
	depth=0;

}

node::node(node *basenode)
{
	// This added function will allow to create/duplicate
	// a new node.
	arraycp(basenode->data,data);
	id=++ident;
	parent=NULL;
	sister=NULL;
	child=NULL;
	next=NULL;
	prev=NULL;
	depth=0;

}

node::~node()
{
	if(next) next->prev=prev;
	if(prev) prev->next=next;

}

void node::printfile(FILE *ofp)
{

	fprintf(ofp,"%d %d %d %d %d %d %d %d %d \n",
		data[0], data[1], data[2],
		data[3], data[4], data[5],
		data[6], data[7], data[8]);

}

void node::printdata()
{
	int i=0;
	printf("%d %d %d %d %d %d %d %d %d \n",
			data[0], data[1], data[2],
			data[3], data[4], data[5],
			data[6], data[7], data[8]);

}


void node::stuffdata(int a, int b, int c, int d , int e, int f, 
					 int g , int h, int i)
{	

	data[0]=a;
	data[1]=b;
	data[2]=c;
	data[3]=d;
	data[4]=e;
	data[5]=f;
	data[6]=g;
	data[7]=h;
	data[8]=i;

}

void node::stuffdata(int source[])
{
	arraycp(source, data);
}


//////////////////////////////////////////////////////////////////////
// linklist Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

linklist::linklist()
{
// The linklist is designed as follows:
// The head points to the top node;
// the top node has prev and next.
// the top node's next points to the next node
// and next node points to the top node.
// Both ends of the node points to NULL
// END pointer points to the last node....after 
// all the next's.....
	//
	//
	//   head ->	------
	//				|  p |
	//				|    |
	//				|  N |
	//				------
	//					|
	//					|
	//				------
	//				|  p |
	//				|    |
	//	end->		|  N |
	//				------
	//					

	linklist::head=NULL;
	linklist::end=NULL;
	numnode=0;
	
}

linklist::~linklist()
{

}

void linklist::addnode(node* nwnode,char type)
{
	//puts a node in this link list.
	// this does not "create" a node
	// since a node has already been 
	// created.
	// by default it will add to the head, but
	// if addnode is invoked with another letter
	// other than 'h', it will add from the end.

	node* tmpnode;
	tmpnode= nwnode;
	node* oldhead;
	oldhead=head;
	// check if adding on a null list:
	// kinda messy...
	if (numnode==0) 
	{
		linklist::head=tmpnode;
		linklist::end=tmpnode;
	}
	else
	{
		//puts the new node on the top.
		//did some relinking....
		//remember the node does NOT point to
		// the head, but the head points to
		// the top node. This way I can start
		// a recursion and end it by a null.
	
		if(type=='h')
		{	
			head->prev=tmpnode;
			tmpnode->next=head;
			head=tmpnode;
		}
		else
		{
			end->next=tmpnode;
			tmpnode->prev=end;
			end=tmpnode;
		}
	}
		
	numnode++;


}


void linklist::listprint()
{
	node* ptr;
	ptr=linklist::head;
	while(ptr)
	{
		ptr->printdata();
		ptr=ptr->next;
	}
	printf("\n");

}


void linklist::listdata()
{

	node* ptr;
	ptr=linklist::head;
	while(ptr)
	{
		ptr->printdata();
		ptr=ptr->next;
	}



}

node *linklist::pop()
{
	node* tmp_ptr;
	tmp_ptr=linklist::head;
	if(numnode == 0) return NULL;

	if (numnode <=1)
	{
		head=NULL;
		end=NULL;
	}
	else
	{
		head->next->prev=NULL;
		head=head->next;
		tmp_ptr->next=NULL;
	}

	numnode--;
	return tmp_ptr;

}
//////////////////////////////////////////////////////////////////////
// tree Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

tree::tree()
{
	root=NULL;
	curptr=NULL;
	numnode=0;
	printmode='d';
}

tree::~tree()
{

}

void tree::addnode(node *anode, char type)
{
	//the use of addnode is to add
	// a node either as the child or 
	// sibling of the node. if type is "c"
	// then it means adding the new node
	// as a CHILD of the current node.
	// if the type is "s" then it means adding
	// the new node as a sibling of that node.

	// implementation problem:
	// what if the tree has 0 node.
	// what if the curptr's node already has a 
	// child and u are adding a child to it?
	// what if the curptr's node already has a 
	// sibling and u are adding a sibling to it?


	// it seems like easier to implement add sibling
	// first because once that's set, if the curptr
	// has a child and u need to add a child, then
	// just addsibling to that child.
	
	// in anycase, numnode will only increment if node
	// is added via here, not addchild or addsibling.
	if(numnode==0)
	{
		tree::root=anode;
		tree::curptr=anode;
		anode->depth=0;
	}
	else
	{
		if(type=='c') addchild(anode);
		else addsibling(curptr,anode);
		anode->depth=anode->parent->depth +1;
	}
	numnode++;


}

void tree::addchild(node *anode)
{

	if(!curptr->child)  // do this only if there's no child...
	{
		anode->parent=curptr;
		curptr->child=anode;
	}
	else
	{
		// adding node to the child's sibling.
		// i realized i can't just addsibling to this
		// because curptr is not pointing at the right place.
		// yet i don't want to change the curptr!
		// maybe if i add another parameter to addsibling....
		addsibling(curptr->child, anode);
	}

}

void tree::addsibling(node* from_ptr, node* anode)
{
	if(!from_ptr->sister)
	{
		anode->parent=from_ptr->parent;
		from_ptr->sister= anode;
	}
	else tree::addsibling(from_ptr->sister, anode);

};

void tree::printpath()
{
	// for dfs, printmode = 'd'
	// for bfs, printmode = 'b'
	// for path, printmode = 'p'
	printmode='p';
	node *tmpptr=curptr;
	if(tmpptr)
	{
		recurseprint(tmpptr);

	}
	else return;
}

void tree::recurseprint(node *tmpptr)
{
	if(printmode=='b')
	{
		// perform depth first search printing
		tmpptr->printdata();
		if(tmpptr->child) recurseprint(tmpptr->child);
		if(tmpptr->sister) recurseprint(tmpptr->sister);
	}
	else
	{
		if(printmode=='p')
		{
			// perform path printing
			if(tmpptr->parent) recurseprint(tmpptr->parent);
			tmpptr->printdata();
		}
	}

  
}


void tree::printbfs()
{
	// for dfs, printmode = 'd'
	// for bfs, printmode = 'b'
	printmode='b';
	node *tmpptr=root;
	if(tmpptr)
	{
		recurseprint(tmpptr);
	}
	else return;

}



bool tree::querydata(node *tnode)
{
	//tested...this function works!
	node *tmpptr;
	tmpptr=tree::curptr;
	if(numnode >= 1)
	{
		while(tmpptr)
		{
			if (datamatch(tmpptr, tnode))
				return true;
			else
				tmpptr=tmpptr->parent;
		}
	}

	return false;
}

bool tree::datamatch(node *a, node *b)
{

	int i = 0;
	for (i=0;i<9;i++)
	{
		if (!(a->data[i]==b->data[i]))
		{
			return false;
		}
	}
	return true;
}


void tree::printpathfile(FILE *ofp)
{
	node *tmpptr=curptr;
	if(tmpptr)
	{
		recursefileprint(tmpptr,ofp);

	}
	else return;

}

void tree::recursefileprint(node *tmpptr,FILE *ofp)
{

	if(tmpptr->parent) recursefileprint(tmpptr->parent,ofp);
	tmpptr->printfile(ofp);

}
